/* Ansteuerung des Fischer-Technik Interface ueber die	       */
/* CENTRONICS-Schnittstelle				       */
/*							       */
/* Stand 23.11.93, Topmann				       */
/*	 22.02.94					       */
/* Kabelbelegung:					       */
/* 10-adriges Kabel von BLAU aus:			       */
/*							       */
/*-------------------------------------------------------------*/
/* Ader    PIN	Funktion     Abfrage	     Interface	       */
/*			     (STATUSPORT)		       */
/*-------------------------------------------------------------*/
/*   1	    18	GROUND			   ! Masse	       */
/*   2	     2	DATA 1			   ! LOAD-OUT	  C    */
/*   3	     3	DATA 2			   ! LOAD-IN	  D    */
/*   4	     4	DATA 3			   ! DATA-OUT	  E    */
/*   5	     5	DATA 4			   ! CLOCK	  F    */
/*   6	    13	SLCT	      & 16	   ! COUNT-IN	  6    */
/*   7	     6	DATA 5			   ! TRIGGER-X	  H    */
/*   8	     7	DATA 6			   ! TRIGGER-Y	  J    */
/*   9					     Takt ?	       */
/*  10	    12	PAPER END     & 32	   ! DATA-IN	  L    */
/*-------------------------------------------------------------*/
#include "conio.h"
#include "stdio.h"
#include "time.h"

#define DATAPORT	   0x0378
#define STATUSPORT	0x0379
#define CONTROLPORT	0x037A

/* Doku-kompatible Anweisungen */
#define L1V X1V(fischptr)
#define L1Z X1Z(fischptr)
#define L2V X2V(fischptr)
#define L2Z X2Z(fischptr)

#define L1R X1R(fischptr)
#define L1A X1A(fischptr)
#define L1L X1L(fischptr)
#define L2R X2R(fischptr)
#define L2A X2A(fischptr)
#define L2L X2L(fischptr)
#define L3R X3R(fischptr)
#define L3A X3A(fischptr)
#define L3L X3L(fischptr)
#define L4R X4R(fischptr)
#define L4A X4A(fischptr)
#define L4L X4L(fischptr)
#define LDE XDE(fischptr)
#define LIN XIN(fischptr)


#define E0  fischptr->schalter[0]
#define E1  fischptr->schalter[1]
#define E2  fischptr->schalter[2]
#define E3  fischptr->schalter[3]
#define E4  fischptr->schalter[4]
#define E5  fischptr->schalter[5]
#define E6  fischptr->schalter[6]
#define E7  fischptr->schalter[7]
#define EX  fischptr->analog[0]
#define EY  fischptr->analog[1]

#define EIN '1'
#define AUS '0'

struct FISCH
	  {
	  char m1;
	  char m2;
	  char m3;
	  char m4;
	  char schalter[8];
	  int analog[2];
	  };


/* Doku-kompatible Anweisungen */
void X1V(struct FISCH *fischptr);
void X1Z(struct FISCH *fischptr);
void X1L(struct FISCH *fischptr);
void X1R(struct FISCH *fischptr);
void X1A(struct FISCH *fischptr);
void X2L(struct FISCH *fischptr);
void X2R(struct FISCH *fischptr);
void X2A(struct FISCH *fischptr);
void X3L(struct FISCH *fischptr);
void X3R(struct FISCH *fischptr);
void X3A(struct FISCH *fischptr);
void X4L(struct FISCH *fischptr);
void X4R(struct FISCH *fischptr);
void X4A(struct FISCH *fischptr);
void XDE(struct FISCH *fischptr);   /* Digitaleingaenge lesen */
void XIN(struct FISCH *fischptr);

void sleep (clock_t wait);	    /* Zeitschleife */

/*------------------------------------------------------------*/
/* Struktur initialisieren				      */
/*------------------------------------------------------------*/
void finit (struct FISCH *fischptr);
