/*----------------------------------------------------------------*/
/* Verpackung der ft-Funktionen in eine DLL                       */
/*                                                                */
/*                                            FTDLL.C             */
/*----------------------------------------------------------------*/
/* 210198 TOPM CREATE                                             */
/* 211198 TOPM 32-Bit-Variante                                    */
/*----------------------------------------------------------------*/
/*--  Betriebssystemabhaengige Befehlsformate.    --*/
/*--  Noetig, weil bei DLL-Einsatz die WINDOWS-   --*/
/*--  spezifischen Formate nicht auf der Annahme  --*/
/*--  DS==SS beruhen.                             --*/

#ifdef WINDOWS
  #include <windows.h>
  #define SPRINTF  wsprintf
  #define STRCPY   lstrcpy
  #define STRNCPY  lstrcpyn
  #define STRCAT   lstrcat
#else
   #define SPRINTF  sprintf
   #define STRCPY   strcpy
   #define STRNCPY  strncpy
   #define STRCAT   strcat
#endif

#ifdef WIN32
   #define _fstrlen strlen
   #define _far
   #define __pascal
#endif

#include "ft.h"

/*-- Struktur mit Zustandsdaten der ft-Interface-Verbindung --*/
struct FISCH globft;

/*-- lokale Zustandsvariablen --*/
static BOOL IstInitialisiert = FALSE;

/*-- Programmname und Aenderungsdatum --*/
static unsigned char * NAME     = "FTDLL.C 211198";

/*------------------------------------------------------------*/
/*    Zustand Schalter x                                      */
/*------------------------------------------------------------*/
BOOL WINAPI Exdll (int inSchalter);


HINSTANCE globInst = NULL;

#ifdef WIN32
BOOL WINAPI DllMain (HANDLE hInst,
                     ULONG  ul_reason_for_call,
                     LPVOID reserved)
   {
   BOOL erg= TRUE;

   switch (ul_reason_for_call)
      {
      case DLL_PROCESS_ATTACH:
         /* A new process is attempting to access the DLL; one thread is assumed. */
                 break;
      case DLL_THREAD_ATTACH:
         /* A new thread of an existing process is attempting to access the DLL; this call is made beginning with the second thread of a process attaching to the DLL.*/
                 break;
      case DLL_PROCESS_DETACH:
         /*A process is detaching from the DLL.*/
                 break;
      case DLL_THREAD_DETACH:
         /* One of the additional threads (not the first thread) of a process is detaching from the DLL.*/
             break;
          };
   return erg;
   }
#endif
#ifdef WIN16
/*----------------------------------------------------------------*/
/* DLL initialisieren                                             */
/* wird von LIBENTRY.ASM aufgerufen                               */
/*----------------------------------------------------------------*/
int FAR PASCAL LibMain( HINSTANCE hinst,
                        WORD      wDataSeg,
                        WORD      cbHeapSize,
                        LPSTR     lpszCmdLine )

{
if (cbHeapSize != 0)
   UnlockData(0);
globInst = hinst;
return 1;
}
#endif

/*----------------------------------------------------------------*/
/* DLL beenden (Termination)                                      */
/*----------------------------------------------------------------*/
#ifdef WIN16
int FAR PASCAL WEP( int nParameter)

{
if (nParameter == WEP_SYSTEM_EXIT)
   {
   /*-- System shutdown --*/
   return 1;
   }
else
   {
   if (nParameter == WEP_FREE_DLL)
      {
      /*-- DLL use count = 0 --*/
      return 1;
      }
   else
      return 1;
   };
}
#endif


/*----------------------------------------------------------------*/
/*-- Initialisiert die Zustandsdaten in der Struktur globft     --*/
/*----------------------------------------------------------------*/
BOOL WINAPI ftInit ()
   {
   BOOL erg = TRUE; 
   IstInitialisiert = TRUE;
   
   finit (&globft);  
   return erg;
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 1                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E1dll ()

   {   
   return Exdll (0);
   }
/*------------------------------------------------------------*/
/*    Zustand Schalter 2                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E2dll ()

   {   
   return Exdll (1);
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 3                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E3dll ()

   {   
   return Exdll (2);
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 4                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E4dll ()

   {   
   return Exdll (3);
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 5                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E5dll ()

   {   
   return Exdll (4);
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 6                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E6dll ()

   {   
   return Exdll (5);
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 7                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E7dll ()

   {   
   return Exdll (6);
   }

/*------------------------------------------------------------*/
/*    Zustand Schalter 8                                      */
/*------------------------------------------------------------*/
BOOL WINAPI E8dll ()

   {   
   return Exdll (7);
   }


/*------------------------------------------------------------*/
/*    Zustand Schalter x                                      */
/*------------------------------------------------------------*/
BOOL WINAPI Exdll (int inSchalter)

   {
   BOOL erg = FALSE; 
   if (! IstInitialisiert)
      ftInit();

   XDE(&globft);
   if (globft.schalter [inSchalter] == '1')
      erg = 1;
   else 
      erg = 0;   
   return erg;  
   }

/*------------------------------------------------------------*/
/*    Motor 1 links                                           */
/*------------------------------------------------------------*/
void WINAPI M1Ldll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X1A (&globft);
   X1L (&globft);  
   }
/*------------------------------------------------------------*/
/*    Motor 1 rechts                                          */
/*------------------------------------------------------------*/
void WINAPI M1Rdll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X1A (&globft);
   X1R (&globft);  
   }

/*------------------------------------------------------------*/
/*    Motor 2 links                                           */
/*------------------------------------------------------------*/
void WINAPI M2Ldll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X2A (&globft);
   X2L (&globft);  
   }
/*------------------------------------------------------------*/
/*    Motor 2 rechts                                          */
/*------------------------------------------------------------*/
void WINAPI M2Rdll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   
   X2A (&globft);
   X2R (&globft);  
   }

/*------------------------------------------------------------*/
/*    Motor 3 links                                           */
/*------------------------------------------------------------*/
void WINAPI M3Ldll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X3A (&globft);
   X3L (&globft);  
   }
/*------------------------------------------------------------*/
/*    Motor 3 rechts                                          */
/*------------------------------------------------------------*/
void WINAPI M3Rdll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X3A (&globft);
   X3R (&globft);  
   }

/*------------------------------------------------------------*/
/*    Motor 4 links                                           */
/*------------------------------------------------------------*/
void WINAPI M4Ldll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X4A (&globft);
   X4L (&globft);  
   }
/*------------------------------------------------------------*/
/*    Motor 4 rechts                                          */
/*------------------------------------------------------------*/
void WINAPI M4Rdll ()

   {   
   if (! IstInitialisiert)
      ftInit();
   X4A (&globft);
   X4R (&globft);  
   }



/*----------------------------------------------------------------*/
/*--                                                            --*/
/*----------------------------------------------------------------*/
#ifdef WIN16
int exit (int rc)

{
/* PostQuitMessage (0);*/
/* FatalAppExit (NULL, "ZIS: Programm wird abgebrochen"); */
return 12;
}
#endif

